<html>
<head>
<title>OgreNode.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreNode.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreNode_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Node_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Node_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix3_8h.html">OgreMatrix3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreMesh_8h.html">OgreMesh.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreUserObjectBindings_8h.html">OgreUserObjectBindings.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00062"></a><a class="code" href="classOgre_1_1Node.html">00062</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">NodeAlloc</a>
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99">00067</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a>
<a name="l00068"></a>00068         {
<a name="l00070"></a><a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99afcc5f69a4f8962eec29c8b57c1a675a2">00070</a>             <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99afcc5f69a4f8962eec29c8b57c1a675a2" title="Transform is relative to the local space.">TS_LOCAL</a>,
<a name="l00072"></a><a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99a34e6c3ebabc2e9fa00de4f62be0ce7ce">00072</a>             <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99a34e6c3ebabc2e9fa00de4f62be0ce7ce" title="Transform is relative to the space of the parent node.">TS_PARENT</a>,
<a name="l00074"></a><a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99ae28ff4f09161c3f5d19c08c5ef210e04">00074</a>             TS_WORLD
<a name="l00075"></a>00075         };
<a name="l00076"></a><a class="code" href="classOgre_1_1Node.html#ad926e6275c4c0ebe1e28eda5826c2945">00076</a>         <span class="keyword">typedef</span> HashMap&lt;String, Node*&gt; <a class="code" href="classOgre_1_1Node.html#ad926e6275c4c0ebe1e28eda5826c2945">ChildNodeMap</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1Node.html#a89264ee7507c7f820e57408de1fcc561">00077</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;ChildNodeMap&gt;</a> <a class="code" href="classOgre_1_1Node.html#a89264ee7507c7f820e57408de1fcc561">ChildNodeIterator</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1Node.html#a6e1f37403c498444d14137aa82de1573">00078</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;ChildNodeMap&gt;</a> <a class="code" href="classOgre_1_1Node.html#a6e1f37403c498444d14137aa82de1573">ConstChildNodeIterator</a>;
<a name="l00079"></a>00079 
<a name="l00082"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html">00082</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Node_1_1Listener.html" title="Listener which gets called back on Node events.">Listener</a>
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084         <span class="keyword">public</span>:
<a name="l00085"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html#a0808cd3ddd6a1ec90ce947677839aab8">00085</a>             <a class="code" href="classOgre_1_1Node_1_1Listener.html#a0808cd3ddd6a1ec90ce947677839aab8">Listener</a>() {}
<a name="l00086"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html#a2592c473e74e12379be9fdd2d94aa473">00086</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node_1_1Listener.html#a2592c473e74e12379be9fdd2d94aa473">~Listener</a>() {}
<a name="l00094"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html#a4038dce943694bf4577fc99aa76c99ec">00094</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node_1_1Listener.html#a4038dce943694bf4577fc99aa76c99ec" title="Called when a node gets updated.">nodeUpdated</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>*) {}
<a name="l00096"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html#a1bba5bb036e7e21e44520d4a302deb45">00096</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node_1_1Listener.html#a1bba5bb036e7e21e44520d4a302deb45" title="Node is being destroyed.">nodeDestroyed</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>*) {}
<a name="l00098"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html#a94f0833d9ba1ac036c7c9274a77a3bb7">00098</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node_1_1Listener.html#a94f0833d9ba1ac036c7c9274a77a3bb7" title="Node has been attached to a parent.">nodeAttached</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>*) {}
<a name="l00100"></a><a class="code" href="classOgre_1_1Node_1_1Listener.html#a2d8d30e7eb00989dc97aa0c2e1c94d36">00100</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node_1_1Listener.html#a2d8d30e7eb00989dc97aa0c2e1c94d36" title="Node has been detached from a parent.">nodeDetached</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>*) {}
<a name="l00101"></a>00101         };
<a name="l00102"></a>00102 
<a name="l00104"></a><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html">00104</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html" title="Inner class for displaying debug renderable for Node.">DebugRenderable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">NodeAlloc</a>
<a name="l00105"></a>00105         {
<a name="l00106"></a>00106         <span class="keyword">protected</span>:
<a name="l00107"></a><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#a2ee5f69c25270e9ba2711394f9b5e658">00107</a>             <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#a2ee5f69c25270e9ba2711394f9b5e658">mParent</a>;
<a name="l00108"></a><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#a31eb8360e79c5d6824431818612979c6">00108</a>             <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#a31eb8360e79c5d6824431818612979c6">mMeshPtr</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#aaf25b16bc2bead3d73b2b1824084ba53">00109</a>             <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#aaf25b16bc2bead3d73b2b1824084ba53">mMat</a>;
<a name="l00110"></a><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#ac333726333491503ad9737114aef7bcd">00110</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#ac333726333491503ad9737114aef7bcd">mScaling</a>;
<a name="l00111"></a>00111         <span class="keyword">public</span>:
<a name="l00112"></a>00112             <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html" title="Inner class for displaying debug renderable for Node.">DebugRenderable</a>(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent);
<a name="l00113"></a>00113             ~<a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html" title="Inner class for displaying debug renderable for Node.">DebugRenderable</a>();
<a name="l00114"></a>00114             <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00115"></a>00115             <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00116"></a>00116             <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00117"></a>00117             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00118"></a>00118             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00119"></a><a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#a0aa6fef253ed7a749d0c896aee357cb8">00119</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html#a0aa6fef253ed7a749d0c896aee357cb8">setScaling</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> s) { mScaling = s; }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121         };
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="keyword">protected</span>:
<a name="l00125"></a><a class="code" href="classOgre_1_1Node.html#a24d11a360b70ac6f37e4287bfbc223f7">00125</a>         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* <a class="code" href="classOgre_1_1Node.html#a24d11a360b70ac6f37e4287bfbc223f7" title="Pointer to parent node.">mParent</a>;
<a name="l00127"></a><a class="code" href="classOgre_1_1Node.html#ad508313713b823331eca7a3f6a4fd002">00127</a>         <a class="code" href="classOgre_1_1Node.html#ad926e6275c4c0ebe1e28eda5826c2945">ChildNodeMap</a> <a class="code" href="classOgre_1_1Node.html#ad508313713b823331eca7a3f6a4fd002" title="Collection of pointers to direct children; hashmap for efficiency.">mChildren</a>;
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classOgre_1_1Node.html#aeeff7ca93bca86e92195a69a2cdfe502">00129</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;Node*&gt;::type</a> <a class="code" href="classOgre_1_1Node.html#aeeff7ca93bca86e92195a69a2cdfe502">ChildUpdateSet</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1Node.html#a54aa00f1ca77a93516bc2d1b08b30648">00131</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Node.html#aeeff7ca93bca86e92195a69a2cdfe502">ChildUpdateSet</a> <a class="code" href="classOgre_1_1Node.html#a54aa00f1ca77a93516bc2d1b08b30648" title="List of children which need updating, used if self is not out of date but children are...">mChildrenToUpdate</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1Node.html#ae964b315ed79aef118b71b4c3b6466cd">00133</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#ae964b315ed79aef118b71b4c3b6466cd" title="Flag to indicate own transform from parent is out of date.">mNeedParentUpdate</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1Node.html#a4d4eff00d6dbea91264b52046cc367b5">00135</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#a4d4eff00d6dbea91264b52046cc367b5" title="Flag indicating that all children need to be updated.">mNeedChildUpdate</a>;
<a name="l00137"></a><a class="code" href="classOgre_1_1Node.html#ab270a19a8d2466230f5906883534d1b0">00137</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#ab270a19a8d2466230f5906883534d1b0" title="Flag indicating that parent has been notified about update request.">mParentNotified</a> ;
<a name="l00139"></a><a class="code" href="classOgre_1_1Node.html#a64114e8a49a4db05074790280dc30cf0">00139</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#a64114e8a49a4db05074790280dc30cf0" title="Flag indicating that the node has been queued for update.">mQueuedForUpdate</a>;
<a name="l00140"></a>00140 
<a name="l00142"></a><a class="code" href="classOgre_1_1Node.html#a6580e36ab5bbec5d074efe6bfe0dcd79">00142</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Node.html#a6580e36ab5bbec5d074efe6bfe0dcd79" title="Friendly name of this node, can be automatically generated if you don&#39;t care.">mName</a>;
<a name="l00143"></a>00143 
<a name="l00145"></a><a class="code" href="classOgre_1_1Node.html#ab685c7e9f419db77e0f85331ea3cdca3">00145</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1NameGenerator.html" title="Utility class to generate a sequentially numbered series of names.">NameGenerator</a> <a class="code" href="classOgre_1_1Node.html#ab685c7e9f419db77e0f85331ea3cdca3" title="Incremented count for next name extension.">msNameGenerator</a>;
<a name="l00146"></a>00146 
<a name="l00148"></a><a class="code" href="classOgre_1_1Node.html#a2c40bc581d9ebbbf7e2d056c2bc8ffde">00148</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Node.html#a2c40bc581d9ebbbf7e2d056c2bc8ffde" title="Stores the orientation of the node relative to it&#39;s parent.">mOrientation</a>;
<a name="l00149"></a>00149 
<a name="l00151"></a><a class="code" href="classOgre_1_1Node.html#a9ef4388bfc132db4a7f6a55f0352166e">00151</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Node.html#a9ef4388bfc132db4a7f6a55f0352166e" title="Stores the position/translation of the node relative to its parent.">mPosition</a>;
<a name="l00152"></a>00152 
<a name="l00154"></a><a class="code" href="classOgre_1_1Node.html#a858fbfaad27833ca00f8d0a1adf3093a">00154</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Node.html#a858fbfaad27833ca00f8d0a1adf3093a" title="Stores the scaling factor applied to this node.">mScale</a>;
<a name="l00155"></a>00155 
<a name="l00157"></a><a class="code" href="classOgre_1_1Node.html#ad85766c2f287598bb1059e84ce73e7bb">00157</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#ad85766c2f287598bb1059e84ce73e7bb" title="Stores whether this node inherits orientation from it&#39;s parent.">mInheritOrientation</a>;
<a name="l00158"></a>00158 
<a name="l00160"></a><a class="code" href="classOgre_1_1Node.html#ab10376524767e0b8a9e86964956f0b40">00160</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#ab10376524767e0b8a9e86964956f0b40" title="Stores whether this node inherits scale from it&#39;s parent.">mInheritScale</a>;
<a name="l00161"></a>00161 
<a name="l00163"></a>00163         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setParent(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent);
<a name="l00164"></a>00164 
<a name="l00172"></a><a class="code" href="classOgre_1_1Node.html#a7d7d9e45beb547ba72ce33f0274c1167">00172</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Node.html#a7d7d9e45beb547ba72ce33f0274c1167" title="Cached combined orientation.">mDerivedOrientation</a>;
<a name="l00173"></a>00173 
<a name="l00181"></a><a class="code" href="classOgre_1_1Node.html#a7fc19ff96fcb001d6e9981f439bb0eed">00181</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Node.html#a7fc19ff96fcb001d6e9981f439bb0eed" title="Cached combined position.">mDerivedPosition</a>;
<a name="l00182"></a>00182 
<a name="l00190"></a><a class="code" href="classOgre_1_1Node.html#a2e5ca471f5154645a596cd230ea94af2">00190</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Node.html#a2e5ca471f5154645a596cd230ea94af2" title="Cached combined scale.">mDerivedScale</a>;
<a name="l00191"></a>00191 
<a name="l00198"></a>00198         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateFromParent(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00199"></a>00199 
<a name="l00206"></a>00206         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateFromParentImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00210"></a>00210         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00211"></a>00211 
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) = 0;
<a name="l00214"></a>00214 
<a name="l00216"></a><a class="code" href="classOgre_1_1Node.html#aa23946bc6edd30b225a2f04170f04c89">00216</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Node.html#aa23946bc6edd30b225a2f04170f04c89" title="The position to use as a base for keyframe animation.">mInitialPosition</a>;
<a name="l00218"></a><a class="code" href="classOgre_1_1Node.html#a88590f5a049463362c0d2cec07bdca39">00218</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Node.html#a88590f5a049463362c0d2cec07bdca39" title="The orientation to use as a base for keyframe animation.">mInitialOrientation</a>;
<a name="l00220"></a><a class="code" href="classOgre_1_1Node.html#a3f7a0ccee23accbece0017bec7dcd1ad">00220</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Node.html#a3f7a0ccee23accbece0017bec7dcd1ad" title="The scale to use as a base for keyframe animation.">mInitialScale</a>;
<a name="l00221"></a>00221 
<a name="l00223"></a><a class="code" href="classOgre_1_1Node.html#a88c50934c653fd86447cc81da0998e81">00223</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1Node.html#a88c50934c653fd86447cc81da0998e81" title="Cached derived transform as a 4x4 matrix.">mCachedTransform</a>;
<a name="l00224"></a><a class="code" href="classOgre_1_1Node.html#abeb1d94ee7b8cd7a612a30b510ccee6d">00224</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Node.html#abeb1d94ee7b8cd7a612a30b510ccee6d">mCachedTransformOutOfDate</a>;
<a name="l00225"></a>00225 
<a name="l00227"></a><a class="code" href="classOgre_1_1Node.html#a4cff3c3bdbe9243a4fd8d928c93365d0">00227</a>         <a class="code" href="classOgre_1_1Node_1_1Listener.html" title="Listener which gets called back on Node events.">Listener</a>* <a class="code" href="classOgre_1_1Node.html#a4cff3c3bdbe9243a4fd8d928c93365d0" title="Node listener - only one allowed (no list) for size &amp; performance reasons.">mListener</a>;
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classOgre_1_1Node.html#a747a039791396b55d96c8251186b05cd">00229</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Node*&gt;::type</a> <a class="code" href="classOgre_1_1Node.html#a747a039791396b55d96c8251186b05cd">QueuedUpdates</a>;
<a name="l00230"></a><a class="code" href="classOgre_1_1Node.html#ab0bc2321f649cd0165a442e7d3a8ad6e">00230</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Node.html#a747a039791396b55d96c8251186b05cd">QueuedUpdates</a> <a class="code" href="classOgre_1_1Node.html#ab0bc2321f649cd0165a442e7d3a8ad6e">msQueuedUpdates</a>;
<a name="l00231"></a>00231 
<a name="l00232"></a><a class="code" href="classOgre_1_1Node.html#ac6d7568e730aee21dd64702afa03ba4d">00232</a>         <a class="code" href="classOgre_1_1Node_1_1DebugRenderable.html" title="Inner class for displaying debug renderable for Node.">DebugRenderable</a>* <a class="code" href="classOgre_1_1Node.html#ac6d7568e730aee21dd64702afa03ba4d">mDebug</a>;
<a name="l00233"></a>00233 
<a name="l00235"></a><a class="code" href="classOgre_1_1Node.html#a231ea555d7cc14a041557df9b63d667c">00235</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a> <a class="code" href="classOgre_1_1Node.html#a231ea555d7cc14a041557df9b63d667c" title="User objects binding.">mUserObjectBindings</a>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237     <span class="keyword">public</span>:
<a name="l00242"></a>00242         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>();
<a name="l00247"></a>00247         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>();  
<a name="l00250"></a>00250 
<a name="l00252"></a>00252         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00253"></a>00253 
<a name="l00256"></a>00256         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* getParent(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00257"></a>00257 
<a name="l00260"></a>00260         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp; getOrientation() <span class="keyword">const</span>;
<a name="l00261"></a>00261 
<a name="l00275"></a>00275         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrientation( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q );
<a name="l00276"></a>00276 
<a name="l00290"></a>00290         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrientation( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00291"></a>00291 
<a name="l00305"></a>00305         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetOrientation(<span class="keywordtype">void</span>);
<a name="l00306"></a>00306 
<a name="l00309"></a>00309         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPosition(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos);
<a name="l00310"></a>00310 
<a name="l00313"></a>00313         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00314"></a>00314 
<a name="l00317"></a>00317         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp; getPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00318"></a>00318 
<a name="l00331"></a>00331         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; scale);
<a name="l00332"></a>00332 
<a name="l00345"></a>00345         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setScale(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00346"></a>00346 
<a name="l00349"></a>00349         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp; getScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00350"></a>00350 
<a name="l00364"></a>00364         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInheritOrientation(<span class="keywordtype">bool</span> inherit);
<a name="l00365"></a>00365 
<a name="l00379"></a>00379         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getInheritOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00380"></a>00380 
<a name="l00393"></a>00393         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInheritScale(<span class="keywordtype">bool</span> inherit);
<a name="l00394"></a>00394 
<a name="l00399"></a>00399         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getInheritScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00400"></a>00400 
<a name="l00410"></a>00410         <span class="keyword">virtual</span> <span class="keywordtype">void</span> scale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; scale);
<a name="l00411"></a>00411 
<a name="l00421"></a>00421         <span class="keyword">virtual</span> <span class="keywordtype">void</span> scale(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00422"></a>00422 
<a name="l00432"></a>00432         <span class="keyword">virtual</span> <span class="keywordtype">void</span> translate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; d, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_PARENT);
<a name="l00446"></a>00446         <span class="keyword">virtual</span> <span class="keywordtype">void</span> translate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_PARENT);
<a name="l00466"></a>00466         <span class="keyword">virtual</span> <span class="keywordtype">void</span> translate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; axes, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; move, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_PARENT);
<a name="l00486"></a>00486         <span class="keyword">virtual</span> <span class="keywordtype">void</span> translate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; axes, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_PARENT);
<a name="l00487"></a>00487 
<a name="l00490"></a>00490         <span class="keyword">virtual</span> <span class="keywordtype">void</span> roll(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_LOCAL);
<a name="l00491"></a>00491 
<a name="l00494"></a>00494         <span class="keyword">virtual</span> <span class="keywordtype">void</span> pitch(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_LOCAL);
<a name="l00495"></a>00495 
<a name="l00498"></a>00498         <span class="keyword">virtual</span> <span class="keywordtype">void</span> yaw(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_LOCAL);
<a name="l00499"></a>00499 
<a name="l00502"></a>00502         <span class="keyword">virtual</span> <span class="keywordtype">void</span> rotate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; axis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_LOCAL);
<a name="l00503"></a>00503 
<a name="l00506"></a>00506         <span class="keyword">virtual</span> <span class="keywordtype">void</span> rotate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q, <a class="code" href="classOgre_1_1Node.html#ac42e2063379286eb673eaffff6ca5e99" title="Enumeration denoting the spaces which a transform can be relative to.">TransformSpace</a> relativeTo = TS_LOCAL);
<a name="l00507"></a>00507 
<a name="l00510"></a>00510         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> getLocalAxes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00511"></a>00511 
<a name="l00518"></a>00518         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChild(
<a name="l00519"></a>00519             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, 
<a name="l00520"></a>00520             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a> );
<a name="l00521"></a>00521 
<a name="l00531"></a>00531         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>);
<a name="l00532"></a>00532 
<a name="l00537"></a>00537         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addChild(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* child);
<a name="l00538"></a>00538 
<a name="l00541"></a>00541         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numChildren(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00542"></a>00542 
<a name="l00547"></a>00547         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* getChild(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;    
<a name="l00548"></a>00548 
<a name="l00551"></a>00551         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* getChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00552"></a>00552 
<a name="l00563"></a>00563         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">ChildNodeIterator</a> getChildIterator(<span class="keywordtype">void</span>);
<a name="l00564"></a>00564 
<a name="l00575"></a>00575         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstChildNodeIterator</a> getChildIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00576"></a>00576 
<a name="l00584"></a>00584         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* removeChild(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00592"></a>00592         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* removeChild(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* child);
<a name="l00593"></a>00593 
<a name="l00599"></a>00599         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* removeChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00603"></a>00603         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllChildren(<span class="keywordtype">void</span>);
<a name="l00604"></a>00604         
<a name="l00609"></a>00609         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDerivedPosition(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos);
<a name="l00610"></a>00610 
<a name="l00616"></a>00616         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDerivedOrientation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q);
<a name="l00617"></a>00617 
<a name="l00620"></a>00620         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp; _getDerivedOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00621"></a>00621 
<a name="l00624"></a>00624         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp; _getDerivedPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00625"></a>00625 
<a name="l00628"></a>00628         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp; _getDerivedScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00629"></a>00629 
<a name="l00639"></a>00639         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; _getFullTransform(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00640"></a>00640 
<a name="l00653"></a>00653         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _update(<span class="keywordtype">bool</span> updateChildren, <span class="keywordtype">bool</span> parentHasChanged);
<a name="l00654"></a>00654 
<a name="l00660"></a><a class="code" href="classOgre_1_1Node.html#ac958f0d4fad0970aa65bdd0f86de6781">00660</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node.html#ac958f0d4fad0970aa65bdd0f86de6781" title="Sets a listener for this Node.">setListener</a>(<a class="code" href="classOgre_1_1Node_1_1Listener.html" title="Listener which gets called back on Node events.">Listener</a>* listener) { mListener = listener; }
<a name="l00661"></a>00661         
<a name="l00664"></a><a class="code" href="classOgre_1_1Node.html#abfe7b8c3bd9e9afadaeff3544906ade0">00664</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Node_1_1Listener.html" title="Listener which gets called back on Node events.">Listener</a>* <a class="code" href="classOgre_1_1Node.html#abfe7b8c3bd9e9afadaeff3544906ade0" title="Gets the current listener for this Node.">getListener</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mListener; }
<a name="l00665"></a>00665         
<a name="l00666"></a>00666 
<a name="l00677"></a>00677         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInitialState(<span class="keywordtype">void</span>);
<a name="l00678"></a>00678 
<a name="l00680"></a>00680         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetToInitialState(<span class="keywordtype">void</span>);
<a name="l00681"></a>00681 
<a name="l00686"></a>00686         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getInitialPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00687"></a>00687         
<a name="l00689"></a>00689         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> convertWorldToLocalPosition( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp;worldPos );
<a name="l00690"></a>00690 
<a name="l00693"></a>00693         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> convertLocalToWorldPosition( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> &amp;localPos );
<a name="l00694"></a>00694 
<a name="l00696"></a>00696         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> convertWorldToLocalOrientation( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp;worldOrientation );
<a name="l00697"></a>00697 
<a name="l00700"></a>00700         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> convertLocalToWorldOrientation( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> &amp;localOrientation );
<a name="l00701"></a>00701 
<a name="l00703"></a>00703         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getInitialOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00704"></a>00704 
<a name="l00706"></a>00706         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getInitialScale(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00707"></a>00707 
<a name="l00709"></a>00709         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00710"></a>00710 
<a name="l00718"></a>00718         <span class="keyword">virtual</span> <span class="keywordtype">void</span> needUpdate(<span class="keywordtype">bool</span> forceParentUpdate = <span class="keyword">false</span>);
<a name="l00723"></a>00723         <span class="keyword">virtual</span> <span class="keywordtype">void</span> requestUpdate(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* child, <span class="keywordtype">bool</span> forceParentUpdate = <span class="keyword">false</span>);
<a name="l00725"></a>00725         <span class="keyword">virtual</span> <span class="keywordtype">void</span> cancelUpdate(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* child);
<a name="l00726"></a>00726 
<a name="l00728"></a>00728         <span class="keyword">virtual</span> DebugRenderable* getDebugRenderable(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaling);
<a name="l00729"></a>00729 
<a name="l00737"></a>00737         <span class="keyword">static</span> <span class="keywordtype">void</span> queueNeedUpdate(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* n);
<a name="l00739"></a>00739         <span class="keyword">static</span> <span class="keywordtype">void</span> processQueuedUpdates(<span class="keywordtype">void</span>);
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00749"></a><a class="code" href="classOgre_1_1Node.html#aa3a25fc37acf61b1b4fd1716c0196ee1">00749</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Node.html#aa3a25fc37acf61b1b4fd1716c0196ee1">setUserAny</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; anything) { getUserObjectBindings().setUserAny(anything); }
<a name="l00750"></a>00750 
<a name="l00754"></a><a class="code" href="classOgre_1_1Node.html#a523f3ce4069716f15c97acfa22ec8214">00754</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1Node.html#a523f3ce4069716f15c97acfa22ec8214">getUserAny</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> getUserObjectBindings().getUserAny(); }
<a name="l00755"></a>00755 
<a name="l00760"></a><a class="code" href="classOgre_1_1Node.html#af3fcf16e43b07e046816125cbb8dc8f3">00760</a>         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1Node.html#af3fcf16e43b07e046816125cbb8dc8f3" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>() { <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00761"></a>00761 
<a name="l00766"></a><a class="code" href="classOgre_1_1Node.html#ab1fd9a93c1ef3d499ba8f332317b9eae">00766</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>&amp; <a class="code" href="classOgre_1_1Node.html#ab1fd9a93c1ef3d499ba8f332317b9eae" title="Return an instance of user objects binding associated with this class.">getUserObjectBindings</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUserObjectBindings; }
<a name="l00767"></a>00767 
<a name="l00768"></a>00768     };
<a name="l00772"></a>00772 } <span class="comment">//namespace</span>
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
